// This file was generated by gir (https://github.com/gtk-rs/gir)
// from
// from gir-files (https://github.com/gtk-rs/gir-files)
// DO NOT EDIT

use crate::ffi;
use glib::{prelude::*, translate::*};

glib::wrapper! {
    #[doc(alias = "SpellingLanguageInfo")]
    pub struct LanguageInfo(Object<ffi::SpellingLanguageInfo, ffi::SpellingLanguageInfoClass>);

    match fn {
        type_ => || ffi::spelling_language_info_get_type(),
    }
}

impl LanguageInfo {
    // rustdoc-stripper-ignore-next
    /// Creates a new builder-pattern struct instance to construct [`LanguageInfo`] objects.
    ///
    /// This method returns an instance of [`LanguageInfoBuilder`](crate::builders::LanguageInfoBuilder) which can be used to create [`LanguageInfo`] objects.
    pub fn builder() -> LanguageInfoBuilder {
        LanguageInfoBuilder::new()
    }

    #[doc(alias = "spelling_language_info_get_code")]
    #[doc(alias = "get_code")]
    pub fn code(&self) -> glib::GString {
        unsafe { from_glib_none(ffi::spelling_language_info_get_code(self.to_glib_none().0)) }
    }

    #[doc(alias = "spelling_language_info_get_group")]
    #[doc(alias = "get_group")]
    pub fn group(&self) -> glib::GString {
        unsafe { from_glib_none(ffi::spelling_language_info_get_group(self.to_glib_none().0)) }
    }

    #[doc(alias = "spelling_language_info_get_name")]
    #[doc(alias = "get_name")]
    pub fn name(&self) -> glib::GString {
        unsafe { from_glib_none(ffi::spelling_language_info_get_name(self.to_glib_none().0)) }
    }
}

impl std::fmt::Display for LanguageInfo {
    #[inline]
    fn fmt(&self, f: &mut std::fmt::Formatter) -> std::fmt::Result {
        f.write_str(&self.name())
    }
}

// rustdoc-stripper-ignore-next
/// A [builder-pattern] type to construct [`LanguageInfo`] objects.
///
/// [builder-pattern]: https://doc.rust-lang.org/1.0.0/style/ownership/builders.html
#[must_use = "The builder must be built to be used"]
pub struct LanguageInfoBuilder {
    builder: glib::object::ObjectBuilder<'static, LanguageInfo>,
}

impl LanguageInfoBuilder {
    fn new() -> Self {
        Self {
            builder: glib::object::Object::builder(),
        }
    }

    pub fn code(self, code: impl Into<glib::GString>) -> Self {
        Self {
            builder: self.builder.property("code", code.into()),
        }
    }

    pub fn group(self, group: impl Into<glib::GString>) -> Self {
        Self {
            builder: self.builder.property("group", group.into()),
        }
    }

    pub fn name(self, name: impl Into<glib::GString>) -> Self {
        Self {
            builder: self.builder.property("name", name.into()),
        }
    }

    // rustdoc-stripper-ignore-next
    /// Build the [`LanguageInfo`].
    #[must_use = "Building the object from the builder is usually expensive and is not expected to have side effects"]
    pub fn build(self) -> LanguageInfo {
        self.builder.build()
    }
}
